## SPURIOUS VALLEYS, NP-HARDNESS, AND TRACTABILITY OF SPARSE MATRIX FACTORIZATION WITH FIXED SUPPORT

Code to reproduce experiments in "SPURIOUS VALLEYS, NP-HARDNESS, AND TRACTABILITY OF SPARSE MATRIX FACTORIZATION WITH FIXED SUPPORT" (Quoc-Tung Le, Elisa Riccietti, Rémi Gribonval).

# Quick tutorial
# To reproduce the figure 10: two options
1) Run the file fig10.py: python fig10.py

2) Run the notebook Reproduce_figues.ipynb

# To reproduce the figure 11: two options
1) Run the file fig11.py: python fig11.py

2) Run the notebook Reproduce_figues.ipynb.

# To reproduce PALM behavior and the figure 1:
1) Run the notebook PALMbehavior.ipynb

# Python implementation of Algorithm 3.3 and 3.4: Two options
1) Run the notebook FSMF_demo.ipynb (recommended)

2) Read the file hierarchical_fact.py, which contains the function "solve_DTO" (Algorithm 3.3).

# Other useful detail (about the code structure):
1) hierarchical_fact.py: contain the function "solve_DTO", which is Algorithm 3.3.

2) iterative_method.py: contain the function "training", which is the code running gradient descent and its variants.

3) fig10.py: code to reproduce Figure 10.

4) fig11.py: code to reproduce Figure 11.

5) palm4msa_hierar.py: official python code of pyfaust library.

6) gsigma.py: code to produce Figure 9.

7) HODLR_supp.py: code to produce Figure 4.